/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * CrossbowTreeModel.h
 *  Created on: 23.12.2010
 */

#ifndef CROSSBOWTREEMODEL_H_
#define CROSSBOWTREEMODEL_H_

#include <QAbstractItemModel>
#include <QModelIndex>
#include <QVariant>
#include "Armbrust.h"
#include "UnitConverter.h"

#include "TreeItem.h"
//#include "TreeItem.cpp"
//class ArrowTreeItem;


class CrossbowTreeModel: public QAbstractItemModel {
Q_OBJECT
public:
	CrossbowTreeModel(QObject *parent = 0);
	~CrossbowTreeModel();

	QVariant data(const QModelIndex &index, int role) const;
	Qt::ItemFlags flags(const QModelIndex &index) const;
	QVariant headerData(int section, Qt::Orientation orientation, int role =
			Qt::DisplayRole) const;
	QModelIndex index(int row, int column, const QModelIndex &parent =
			QModelIndex()) const;
	QModelIndex parent(const QModelIndex &index) const;
	int rowCount(const QModelIndex &parent = QModelIndex()) const;
	int columnCount(const QModelIndex &parent = QModelIndex()) const;
	bool removeRow ( int row, const QModelIndex & parent = QModelIndex() );
	bool removeRows ( int row, int count, const QModelIndex & parent = QModelIndex() );
	bool insertRow ( int row, const QModelIndex & parent = QModelIndex() );
	bool insertRows ( int row, int count, const QModelIndex & parent = QModelIndex() );

	TreeItem<CArmbrust> *rootItem;
	std::list<CArmbrust> m_list;
	UnitConverter *m_unitconverter;
    void clear();

//private:
	bool  create_data(TreeItem<CArmbrust> *child, TreeItem<CArmbrust> *parent, CArmbrust *base_item, const QMap<QString, QVariant> &v);

	void write_item(int &depth, TreeItem<CArmbrust> *item);


    CArmbrust* getItem(QModelIndex index);
    bool setItem(QModelIndex index, CArmbrust &a);
    bool setItem(CArmbrust &a);
    bool appendRow(CArmbrust &a);

    QModelIndexList match ( const QModelIndex & start, int role, const QVariant & value, int hits = 1, Qt::MatchFlags flags = Qt::MatchFlags( Qt::MatchStartsWith | Qt::MatchWrap ) ) const;
};


#endif /* CROSSBOWTREEMODEL_H_ */
