/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * Datastore.h
 *  Created on: 30.12.2010
 */

#ifndef DATASTORE_H_
#define DATASTORE_H_

#include <QMap>
#include <QString>
#include <QVariant>
#include <QUuid>
#include <QDomDocument>
#include <QObject>

class Datastore  {


/** a unique idendifier
 *
 */
	QUuid m_guid;

	bool setValue(QString path, QVariant value, QMap<QString, QVariant> & data);
	QVariant getValue(QString path, QMap<QString, QVariant> & data);

public:
	Datastore();
	Datastore(const Datastore & d);//Constructor
	Datastore(const QString guid);

	virtual ~Datastore();

	QMap<QString, QVariant> m_data;
	enum Statusflag {
		preset = 0,
		user = 1 ,
		calculated = 2

	};
	QUuid getGuid(){
		return m_guid;
	};
	Datastore &  operator =(const Datastore & a);
	bool operator ==(const Datastore & a);
	virtual Datastore & take_data(const Datastore & a);

	virtual bool setValue(QString path, QVariant value);
	QVariant getValue(QString path);
	int removeAllChildren(QString path);

	//virtual void init() = 0;

	void map2string(QString &str, const QMap<QString, QVariant> &v);

};

#endif /* DATASTORE_H_ */
