/***************************************************************************
 *   Copyright (C) 2011 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * GraphicsOrthoLineItem.h
 *  Created on: 04.01.2011
 */

#ifndef GRAPHICSORTHOLINEITEM_H_
#define GRAPHICSORTHOLINEITEM_H_

#include <QGraphicsLineItem>
#include <QPen>

class GraphicsOrthoLineItem : public QGraphicsLineItem{

public:
	enum Direction { vertical = 1, horizontal = 2 };
	enum { Type = UserType + 100 };
private:

	bool marked;
	Direction direction;
public:
	GraphicsOrthoLineItem(QGraphicsItem * parent = 0 );
	virtual ~GraphicsOrthoLineItem();
	int number;
	void setLine(qreal x1, qreal y1, qreal xy2, Direction dir);
	QPen *PenSelected;
	QPen *PenNormal;
	void markAsSelected(bool selected);
	//QList<QGraphicsItem *> list
	int type() const { return Type; };
	bool isMarked() {return marked;};
	Direction getDirection() { return direction; };
	/** line in the reticle m/m*/
	double setting;

};

#endif /* GRAPHICSORTHOLINEITEM_H_ */
