/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * SightSettingTable.h
 *  Created on: 21.08.2009
 */

#ifndef SIGHTSETTINGTABLE_H_
#define SIGHTSETTINGTABLE_H_

#include "Armbrust.h"
#include "Pfeil.h"
#include "mainwindow.h"
#include "view.h"

/**
 *@author Herbert Roider
 */

class QTableWidget;
class QPushButton;
class QLabel;
class QLineEdit;
class ArrowmatcherDoc;

class SightSettingTable: public QWidget, public View {
Q_OBJECT
	QPushButton *cmdOk;
	QPushButton *cmdCsvExport;
	QTableWidget *wnd_table;
	QLineEdit *txt_stepsize;
	QLabel *lbl_stepsize;
	double m_stepsize;
	ArrowmatcherDoc *m_pdoc;
	struct savetrajectory_settings {
		QString field_sep;
		QString field_textquote;
		QString open_prog;
	} m_savetrajectory_settings;

	std::vector<utility::vector_3d> m_list_targetpoint_sight;
	std::vector<utility::vector_3d> m_list_targetpoint_crossbow;
	std::vector<utility::vector_3d> m_list_velocity;
	std::vector<double> m_list_time;
	/*
	 * targetpoint from the crossbow system, because the y-axis is the drop and the z-axis is the winddrift
	 */
	std::vector<utility::vector_3d> m_list_drop_drift;
	std::vector<double> m_list_range;

	QString m_csv_content;

protected slots:

	void on_cmdOK_clicked();
	/**
	 * @todo Es werden noch nicht alle Werte exportiert
	 * @brief Export of the values as csv
	 *  @return  void
	 */
	void on_cmdCsvExport_clicked();

public:
	SightSettingTable(QWidget *parent = 0);
	virtual ~SightSettingTable();

	void update(ArrowmatcherDoc * doc);
	void addView(MainWindow* mainwindow);

};

#endif /* SIGHTSETTINGTABLE_H_ */
