/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * TreeItem.h
 *  Created on: 25.12.2010
 */

#ifndef TREEITEM_H_
#define TREEITEM_H_

#include <QVariant>
#include <QTreeWidgetItem>

template<class T> class TreeItem {

public:

    bool isRootItem;
	QList<TreeItem<T>*> childItems;
	QList<QVariant> itemData;
	TreeItem<T> *parentItem;
	bool hidden;

	T * base_item;
	std::list<T> *base_item_list;




	TreeItem(TreeItem<T> *parent)  {
		parentItem = parent;
		base_item = NULL;
		isRootItem = true;
		hidden = false;
	};

	~TreeItem() {
		qDeleteAll(childItems);
	};


	TreeItem<T> *child(int row) {
		TreeItem<T> *items = childItems.value(row);

		return items;
	}

	int childCount()  {
		return this->childItems.size();
	};

	int columnCount() const {
		return 3;
	};

	QVariant data(int column) const {
		return itemData.value(column);

	};

	TreeItem<T> *parent() {
		return parentItem;
	};

	int row() const {
		if (parentItem)
		{
			int row = parentItem->childItems.indexOf(const_cast<TreeItem<T>*> (this));
			return row;
		}
		return 0;
	};

};



#endif /* TREEITEM_H_ */
