/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef UNIT_H
#define UNIT_H

#include <QString>

// Namespace
// Class Unit
//
//
//
class Unit {
	// Public stuff
public:
	enum UnitSystem {
		metric = 0, english = 1

	} m_unitsystem;

	// Fields
	/** The symbol for the Unit f.e.: "m" for Metre, "yd" for Yard
	 *
	 */
	QString m_symbol;
	/**
	 * Name of the Unit f.E.: "Metre" or "Yard"
	 */
	QString m_name;
	/**
	 * Internal identifier for the Unit
	 */
	QString m_type_id;
	/**
	 * the internal identifier for the SI Unit
	 */
	QString m_SI_type_id;
	// Faktor zum Berechnen der SI-Einheit des Wertes
	double m_k;
	// Wert der dazugezählt werden muss zum Berechnen vom SI-Einheitswert
	double m_d;
	//UnitSystem m_unitsystem;
	// Constructors
	// Empty Constructor
	Unit() {
		m_k = 1.0;
		m_d = 0.0;
		m_unitsystem = Unit::metric;

	}
	Unit & operator=(const Unit &u) {
		if (this == &u)
			return *this;
		m_unitsystem = u.m_unitsystem;
		m_symbol = u.m_symbol;
		m_name = u.m_name;
		m_SI_type_id = u.m_SI_type_id;
		m_type_id = u.m_type_id;
		m_k = u.m_k;
		m_d = u.m_d;
		return *this;

	}
	// Accessor Methods


	// Operations
	// Protected stuff
protected:
	// Fields
	// Constructors
	// Accessor Methods
	// Operations
	// Private stuff
private:
	// Fields
	// Constructors
	// Accessor Methods
	// Operations
};
#endif //UNIT_H
