/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * settingcurve.h
 *  Created on: 16.08.2009
 */

#ifndef SETTINGCURVE_H_
#define SETTINGCURVE_H_

#include <ballistic/utility.h>
#include "aspline.h"

using namespace arw;

class akima_curve {
	aspline spline_x;
	aspline spline_y;
	aspline spline_z;

public:
	akima_curve();
	virtual ~akima_curve();

	bool err;
	int insertpoint(double x, utility::vector_3d y);
	int calcspline();
	int spline(utility::vector_3d &y, double x);// calc the y-value for x
	void clear();
//	int numPoints(){
//		return n+1;
//	};
	double minX(){
		return spline_y.minX();

	};
	double maxX(){
		return spline_y.maxX();
	};
	bool not_calculated(){
		if(spline_x.not_calculated() || spline_y.not_calculated() || spline_z.not_calculated())
			return true;
		return false;

	}

};

#endif /* SETTINGCURVE_H_ */
