/***************************************************************************
 *   Copyright (C) 2010 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <QApplication>
#include <QtGui>

#include "mainwindow.h"
#include <QSettings>

int main(int argc, char *argv[])
{
    Q_INIT_RESOURCE(sdi);
    QApplication app(argc, argv);
    app.setOrganizationName("Herbert Roider");
    app.setOrganizationDomain("roider.at");
    app.setApplicationName("arrowmatcher_3");
    app.setApplicationVersion("3.1.2");

    QString fileName;
    QStringList args = app.arguments();
    if(args.size() > 1){
    	fileName = args.at(1);
    }
    //qDebug() << QString("Dateiname:") << fileName << QString("\r\n") ;

	QSettings settings;
	QString locale = settings.value("language").value<QString> () ;
	if(locale.isEmpty()) {
        locale = QLocale::system().name();
	}
    QTranslator translator;
    translator.load(QString(":/arrowmatcher2_") + locale);
    app.installTranslator(&translator);

    MainWindow *mainWin = new MainWindow;
    mainWin->init(fileName);
    mainWin->show();
    return app.exec();
}






