/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider                                  *
 *   herbert.roider@utanet.at                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*
 * sight_diagram_y.cpp
 *  Created on: 08.08.2009
 */

#include "sight_diagram_y.h"
// application specific includes
#include "arrowmatcherdoc.h"
//#include "arrowmatcher.h"
#include "Armbrust.h"
#include <QMenu>

// include files for Qt
//#include <qprinter.h>
#include <QPainter>

//#include <functional>//sortieren//#include <sstream>
#include <QTextStream>
#include <QVector>
//Added by qt3to4:
#include <QMouseEvent>
//#include <Q3PointArray>
#include <QPaintEvent>
//#include <qmemarray.h>
#include <QDebug>

#include <vector>
#include <list>
#include <string>
#include <QRegion>
#include <QMessageBox>
#include <iostream>
#include <stdio.h>
#include <QLayout>
#include <algorithm>
#include <map>
#include <ballistic/utility.h>
#include "sightdiagram_appearancedlg.h"

// Für zeitmessung:
#include <time.h>
#include <iostream>

#include "aspline.h"

sight_diagram_y::sight_diagram_y(QWidget *parent) :
	visier_diagram(parent) {

}

sight_diagram_y::~sight_diagram_y() {

}
int sight_diagram_y::draw_sight_scale(QPainter &dc) {
	//dc.setWindow(0,0,100,100);
	//dc.translate(100.0, 100.0);
	//dc.scale(0.5, 0.5);
	//dc.translate(0.0, 0.0);
	ArrowmatcherDoc *doc = getDocument();
	if (doc == NULL) {
		return 1;
	}
	double dEinstellwert;
	double dIntervall;

	QString s;

	QPen originalPen = dc.pen();
	QFont originalFont = dc.font();
	QBrush originalBrush = dc.brush();
	QFont fontLabelAxis("courier", m_fontheight, QFont::Light);//Beschriftung der beiden Achsen

	QBrush transparentBrush(Qt::NoBrush);
	QPen Absehen(QColor("DarkGrey"), 0, Qt::SolidLine);
	QPen RangeMark(QColor("green"), 0, Qt::SolidLine);// "ForestGreen"
	QPen senkrechteRaster(QColor("LightGrey"), 0, Qt::SolidLine); //helles Grau
	QPen Kurve(QColor("red"), 0, Qt::SolidLine);
	QPen Schriftstift(QColor("black"), 0, Qt::SolidLine);
	QPen red_dash(QColor("red"), 0, Qt::DotLine);
	QPen pen_max_range_mark(QColor("magenta"), 3, Qt::SolidLine);
	QPen pen_Crosshair(QColor("black"), 2, Qt::SolidLine);
	//QBrush      brush_PaleGreen
	QPoint P1;
	QPoint P2;

	QRect test;
	QRect textlabel;//for the values of the diagram-axis

	dc.setPen(Absehen);
	textlabel.setWidth(m_window_area.width() - m_diagram_area.width() - 20);

	if (doc->m_Crossbow.m_Zielgeraet.m_iTyp == KIMME_U_KORN) {
		textlabel.setHeight(dc.fontMetrics().height());// Values for the vertical-axis
		bool drawlabel;
		utility::vector_3d graduation =
				doc->m_Crossbow.m_Zielgeraet.m_graduation;

		// This (10/dFactor_y) should be 3.3 if dFactor = 3.3approximatly
		//dIntervall = fabs( (10.0/dFactor_y) / dSpindelsteigung);//je kleiner die Steigung, desto gr�er die Unterteilung
		dIntervall = fabs(((textlabel.height() / 2.0) / (m_dFactor_y
				* graduation.y * 1000.0)));//je kleiner die Steigung, desto gr�er die Unterteilung
		this->calc_interval(dIntervall);
		//double iFact = 1.0;
		//if(graduation.y < 0.0)
		//	iFact = -1.0;
		//von oben nach unten:
		drawlabel = false;
		double zero_bar_y;
		zero_bar_y = y2diagram(0.0);
		for (dEinstellwert = 0.0; dEinstellwert < 10.0e10; dEinstellwert
				+= dIntervall) {
			drawlabel = (!drawlabel);
			QString text;

			P1.setX(m_diagram_area.left());
			P2.setX(m_diagram_area.right());
			P1.setY(y2diagram(doc->m_Crossbow.m_Zielgeraet.m_graduation.y
					* dEinstellwert  ));

			// Skala geht nach unten:
			if(zero_bar_y < P1.y() ) {
				if (P1.y() > m_diagram_area.bottom() - 10.0)//ganz unten angekommen
					break;
			} else {
				if (P1.y() < m_diagram_area.top() + 10.0)
					break;
			}

			//break;
			P2.setY(P1.y());
			if (!drawlabel)
				Absehen.setStyle(Qt::DotLine);
			else
				Absehen.setStyle(Qt::SolidLine);
			dc.setPen(Absehen);
			//dc.moveTo(P1);
			dc.drawLine(P1, P2);
			if (drawlabel) {

				dc.setPen(Schriftstift);
				textlabel.moveCenter(QPoint(m_diagram_area.left()
						- textlabel.width() / 2, P1.y()));
				//text.setNum(dEinstellwert,'g',5);
				//text.sprintf("%15g",dEinstellwert);
				//text.arg(dEinstellwert);
				text.setNum(dEinstellwert , 'g', 10);
				//dc.drawRect(textlabel);
				dc.drawText(textlabel, Qt::AlignRight, text);
			}
		}
		//von unten hinauf:
		drawlabel = false;
		for (dEinstellwert = 0.0; fabs(dEinstellwert) < 10.0e10; dEinstellwert
				-= dIntervall) {

			drawlabel = (!drawlabel);
			QString text;
			P1.setX(m_diagram_area.left());
			P2.setX(m_diagram_area.right());
			P1.setY(y2diagram(doc->m_Crossbow.m_Zielgeraet.m_graduation.y
					* dEinstellwert));

			// Skala geht nach unten:
			if(zero_bar_y < P1.y() ) {
				if (P1.y() > m_diagram_area.bottom() - 10.0)//ganz unten angekommen
					break;
				if (P1.y() < m_diagram_area.top() + 10.0)
					continue;
			} else {
				if (P1.y() < m_diagram_area.top() + 10.0)
					break;
				if (P1.y() > m_diagram_area.bottom() - 10.0)//ganz unten angekommen
					continue;
			}

			P2.setY(P1.y());
			if (!drawlabel)
				Absehen.setStyle(Qt::DotLine);
			else
				Absehen.setStyle(Qt::SolidLine);
			dc.setPen(Absehen);
			//dc.moveTo(P1);
			dc.drawLine(P1, P2);

			if (drawlabel) {

				dc.setPen(Schriftstift);
				textlabel.moveCenter(QPoint(m_diagram_area.left()
						- textlabel.width() / 2, P1.y()));
				//text.setNum(dEinstellwert,'g',5);
				text.setNum(dEinstellwert, 'g', 10);
				//text.sprintf("%15g",dEinstellwert);
				//text.arg(dEinstellwert);
				//dc.drawRect(textlabel);
				dc.drawText(textlabel, Qt::AlignRight, text);
			}
		}

		s = tr("vertical Sight Setting [Clicks]");
		dc.setPen(Schriftstift);

		dc.translate(m_window_area.left(), m_window_area.bottom());// origin is at left-bottom-corner
		test = QRect(0, 0, m_diagram_area.height(), 20);
		dc.rotate(-90);
		dc.fillRect(test, QBrush(QColor("yellow")));
		dc.drawText(test, Qt::AlignCenter, s);
		dc.rotate(90);
		dc.translate(-m_window_area.left(), -m_window_area.bottom());

	} else //Zeilfernrohr
	{

		double height_of_trajectory;
		double dZerorange; //Fleckentfernung
		double dInitialrange;//nahfleckentfernung
		bool error_zero_range;
		bool error_init_range;
		flight_snapshot beginparam, endparam;
		utility::vector_3d sight_setting;
		QRect textlabel_range;
		QRect textlabel_devitation;
		textlabel_range.setHeight(dc.fontMetrics().height());
		textlabel_range.setWidth(textlabel.width());
		textlabel_devitation.setHeight(dc.fontMetrics().height());
		textlabel_devitation.setWidth(100);

		QVector<double> marks;
		unsigned int iRasternummer;

		qDebug() << doc->m_Crossbow.toString();
		qDebug() << doc->m_Crossbow.m_Zielgeraet.m_marks.size();

		// write the values in a sortable list:
		for (iRasternummer = 0; iRasternummer
				< doc->m_Crossbow.m_Zielgeraet.m_marks.size(); iRasternummer++)
		{
			marks.push_back(doc->m_Crossbow.m_Zielgeraet.m_marks[iRasternummer].y / doc->m_Crossbow.m_Zielgeraet.m_marks[iRasternummer].x);
		}
		qSort(marks.begin(), marks.end(),  qGreater<double>());


		for (iRasternummer = 0; iRasternummer
				< marks.size(); iRasternummer++) ////Querbalken mit Entfernungsangabe zeichnen
		{

			textlabel.setHeight(dc.fontMetrics().lineSpacing() * 2);// Values for the vertical-axis
			textlabel.setWidth(70);
			s = "";
			QString s1 = "";
			sight_setting.y = marks[iRasternummer];
			sight_setting.x = 1.0;
			sight_setting.z = 0.0;

			error_zero_range = doc->m_Crossbow.flightparam_at_zero_range(
					endparam, beginparam, sight_setting, m_fp);
			if (!error_zero_range) {
				s.sprintf("%1.1f\n", doc->m_unitconverter.get_curr_unit_val(endparam.s.x, "SI_metre"));
			} else {
				s.sprintf("- - -\n");
			}
			error_zero_range = doc->m_Crossbow.flightparam_at_init_range(
					endparam, beginparam, sight_setting, m_fp);
			if (!error_init_range) {
				s1.sprintf("%1.1f", doc->m_unitconverter.get_curr_unit_val(endparam.s.x, "SI_metre"));
			} else {
				s1.sprintf("- - -");
			}
			s.append(s1);

			P1.setX(m_diagram_area.left());
			P2.setX(m_diagram_area.right());
			P1.setY(y2diagram(sight_setting.y));

			P2.setY(P1.y());

			if (P1.y() < m_diagram_area.top())//ganz oben angekommen
				continue;
			if (P1.y() > m_diagram_area.bottom() - 10.0)
				continue;

			dc.setPen(pen_Crosshair);
			dc.drawLine(P1, P2);
			dc.setPen(Schriftstift);


			textlabel.moveTopLeft(QPoint(20, iRasternummer * textlabel.height()
					+ (m_window_area.height() - textlabel.height()
							* marks.size()) / 2));
			QPoint
					P_textlabel(textlabel.topRight().x(),
							textlabel.center().y());
			// line from the textlabel to the horizontal line (Absehen, crosshair) in the diagram
			dc.drawLine(P1, P_textlabel);

			dc.fillRect(textlabel, QBrush(QColor("white")));
			dc.drawRect(textlabel);
			dc.drawText(textlabel, Qt::AlignRight, s);

			if (!error_init_range) {
				P1.setX(m_diagram_area.left() + m_dFactor_x * dInitialrange);
				textlabel_range.moveTopLeft(P1);
			}
			if (!error_zero_range) {
				P1.setX(m_diagram_area.left() + m_dFactor_x * dZerorange);
				textlabel_range.moveTopLeft(P1);
			}

		}
		s = tr("Far Zero Range [%1] and Initial Point [%2]");
		s = s.arg(doc->m_unitconverter.get_curr_unit_sym("SI_metre"),doc->m_unitconverter.get_curr_unit_sym("SI_metre"));

		dc.setPen(Schriftstift);
		dc.translate(m_window_area.left(), m_window_area.bottom());// origin is at left-bottom-corner
		test = QRect(0, 0, m_diagram_area.height(), 20);
		dc.rotate(-90);
		dc.fillRect(test, QBrush(QColor("yellow")));
		dc.drawText(test, Qt::AlignCenter, s);
		dc.rotate(90);
		dc.translate(-m_window_area.left(), -m_window_area.bottom()); //os.str("");
	}
	dc.setPen(originalPen);
	dc.setBrush(originalBrush);
	dc.setFont(originalFont);
	return 0;

}
double sight_diagram_y::y2diagram(double setting) {
	if (m_pan_y == 10.0e999) {
		flight_snapshot endparam, beginparam;
		utility::vector_3d center_setting;
		int iFehler = getDocument()->m_Crossbow.sight_setting(center_setting,
				endparam, beginparam, getDocument()->m_Range, m_fp);
		center_setting /= center_setting.x;
		m_pan_y = m_dFactor_y * (1000.0) * center_setting.y;
	}
	return m_dFactor_y * setting * (-1000.0) + m_pan_y + m_diagram_area.top()
			+ m_diagram_area.height() / 2.0;
}
double sight_diagram_y::y2diagram(utility::vector_3d setting) {
	return y2diagram(setting.y);
}
double sight_diagram_y::y_setting(utility::vector_3d setting) {
	return setting.y;
}
