/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "sightdiagram_appearancedlg.h"
#include <QLineEdit>
#include <QListWidget>
#include <QMessageBox>
#include <functional>
#include <algorithm>
#include <ballistic/utility.h>

sightdiagram_appearanceDlg::sightdiagram_appearanceDlg(QWidget *parent) : QDialog(parent) {
    ui.setupUi(this);
    m_ptrAnglelist = NULL;
    m_ptrTargetcirclelist = NULL;
    m_ptrMax_range = NULL;
    m_ptrMax_angle = NULL;

    ui.lstAngle->setSelectionMode( QAbstractItemView::SingleSelection);
    ui.lstAngle->setSelectionBehavior(QAbstractItemView::SelectRows);

    ui.lstTargetcircle->setSelectionMode( QAbstractItemView::SingleSelection );
    ui.lstTargetcircle->setSelectionBehavior(QAbstractItemView::SelectRows);

    //ui.lbl_image->
	QPixmap *image = new QPixmap(":/images/sight_diagram.png");
	ui.lbl_image->setPixmap(*image);


    connect(ui.cmdNewAngle, SIGNAL(clicked()), this, SLOT(cmdNewAngle_click()));
    connect(ui.cmdNewTargetcircle, SIGNAL(clicked()), this, SLOT(cmdNewTargetcircle_click()));
    connect(ui.cmdDeleteAngle, SIGNAL(clicked()), this, SLOT(cmdDeleteAngle_click()));
    connect(ui.cmdDeleteTargetcircle, SIGNAL(clicked()), this, SLOT(cmdDeleteTargetcircle_click()));


}
sightdiagram_appearanceDlg::~sightdiagram_appearanceDlg(){
}
bool sightdiagram_appearanceDlg::init(std::vector<double> *targetcirclelist,
                 std::vector<double> *anglelist,
                 double &max_range,
                 double &max_angle){
    std::vector<double>::iterator iter;
    QString str;
    if(targetcirclelist == NULL)
        return false;
    if(anglelist == NULL)
        return false;

    m_ptrMax_range = &max_range;
    m_ptrMax_angle = &max_angle;

    m_ptrAnglelist = anglelist;
    m_ptrTargetcirclelist = targetcirclelist;

    std::sort(m_ptrAnglelist->begin(), m_ptrAnglelist->end(), std::greater<double>() );
    ui.lstAngle->clear();
    for(iter=m_ptrAnglelist->begin(); iter != m_ptrAnglelist->end(); iter++){
        //QString str;
        //str.setNum((*iter),'g',5);
        //ui.lstAngle->addItem(str);
            QString qstr_value;
            qstr_value.setNum((*iter) * 180.0 / arw::utility::PI,'g',5);
            QListWidgetItem *value = new QListWidgetItem(qstr_value);
            value->setFlags(Qt::ItemIsEditable | Qt::ItemIsSelectable | Qt::ItemIsEnabled);
            //ui.lstAngle->insertRow(ui.lstAngle->rowCount());
            ui.lstAngle->addItem( value);

    }

    std::sort(m_ptrTargetcirclelist->begin(), m_ptrTargetcirclelist->end(), std::greater<double>() );
    ui.lstTargetcircle->clear();
    for(iter=m_ptrTargetcirclelist->begin(); iter != m_ptrTargetcirclelist->end(); iter++){
            QString qstr_value;
            qstr_value.setNum((*iter) * 1000.0,'g',5);
            QListWidgetItem *value = new QListWidgetItem(qstr_value);

            value->setFlags(Qt::ItemIsEditable | Qt::ItemIsSelectable | Qt::ItemIsEnabled);

            ui.lstTargetcircle->addItem(value);
            //QString qstr_value;
            //qstr_value.setNum((*iter),'g',5);
            //QTableWidgetItem *value = new QTableWidgetItem(qstr_value);
            //value->setFlags(Qt::ItemIsEditable);
            //ui.lstTargetcircle->insertRow(ui.lstTargetcircle->rowCount());
            //ui.lstTargetcircle->setItem(ui.lstTargetcircle->rowCount()-1, 0, value);

    }

    str.setNum(*m_ptrMax_range,'g',5);
    ui.txtStretch_x->setText(str);
    str.setNum(*m_ptrMax_angle,'g',5);
    ui.txtStretch_y->setText(str);
    return true;
}
void sightdiagram_appearanceDlg::cmdNewAngle_click(){
    //ui.lstAngle->insertItem("0");
     QString  str_value;

     str_value.setNum(0.0);
     QListWidgetItem *value = new QListWidgetItem(str_value);
     value->setFlags(Qt::ItemIsEditable | Qt::ItemIsSelectable | Qt::ItemIsEnabled);
     //ui.lstAngle->insertRow(ui.lstAngle->rowCount());
     ui.lstAngle->addItem( value);


}
void sightdiagram_appearanceDlg::cmdDeleteAngle_click(){
    ui.lstAngle->takeItem(ui.lstAngle->row(ui.lstAngle->currentItem ()));
    //ui.lstAngle->removeRow(ui.lstAngle->currentRow () );


}
void sightdiagram_appearanceDlg::lstTargetcircle_click(QModelIndex *item){
//     if(item == NULL)
//         return;
//     ui.txtTargetcircle->setText(item->text() );


}
void sightdiagram_appearanceDlg::txtTargetcircle_change(const QString &text){
    //ui.lstTargetcircle->changeItem(text, lstTargetcircle->currentItem () );


}
void sightdiagram_appearanceDlg::cmdCancel_click(){
    reject();

}
void sightdiagram_appearanceDlg::cmdDeleteTargetcircle_click(){
    ui.lstTargetcircle->takeItem(ui.lstTargetcircle->row(ui.lstTargetcircle->currentItem ()));
    //ui.lstTargetcircle->removeRow(ui.lstTargetcircle->currentRow () );


}
void sightdiagram_appearanceDlg::cmdNewTargetcircle_click(){
      QString  str_value;
      str_value.setNum(0.0);
      QListWidgetItem *value = new QListWidgetItem(str_value);
      value->setFlags(Qt::ItemIsEditable | Qt::ItemIsSelectable | Qt::ItemIsEnabled);
        ui.lstTargetcircle->addItem(value);
//      QString  str_value;
//
//      str_value.setNum(0.0);
//      QTableWidgetItem *value = new QTableWidgetItem(str_value);
//      value->setFlags(Qt::ItemIsEditable);
//      ui.lstTargetcircle->addItem(ui.lstTargetcircle->rowCount());
//      ui.lstTargetcircle->setItem(ui.lstTargetcircle->rowCount()-1, 0, value);


}
void sightdiagram_appearanceDlg::accept(){
    double d;
    bool ok;
    std::vector<double> vect;
    if(m_ptrTargetcirclelist == NULL)
        reject();
    if(m_ptrAnglelist == NULL)
        reject();


    for(int row = 0; row < ui.lstAngle->count(); row++){
        QListWidgetItem *value = ui.lstAngle->item(row);
        QString str = value->text();
        double d = str.toDouble(&ok);
        if(ok == false)
        {
            QMessageBox::critical(this, "Arrowmatcher", QString(tr("A value is not a number") ) );
            return;
        }
        d *= arw::utility::PI / 180.0;
        vect.push_back(d );
    }
    std::sort(vect.begin(), vect.end(), std::greater<double>() );
    *m_ptrAnglelist = vect;
    vect.clear();

    for(int i=0; i< ui.lstTargetcircle->count(); i++)
    {
        QListWidgetItem *value = ui.lstTargetcircle->item(i);
        QString str = value->text();
        double d = str.toDouble(&ok);
        if(ok == false)
        {
            QMessageBox::critical(this, "Arrowmatcher", QString(tr("A value is not a number") ) );
            return;
        }
        d /= 1000.0;
        vect.push_back(d );
    }
    std::sort(vect.begin(), vect.end(), std::greater<double>() );
    *m_ptrTargetcirclelist = vect;

    double X = ui.txtStretch_x->text().toDouble();
    double Y = ui.txtStretch_y->text().toDouble();
    if(X <= 1.0|| X > 10000.0){
        QMessageBox::critical(this, "Arrowmatcher", QString(tr("Range-area must be between\n1 and 1000m") ) );
        return;
    }
    if(Y <=0.01 || Y >= 1000.0){
        QMessageBox::critical(this, "Arrowmatcher", QString(tr("Setting-area must be between\n0.01 and 1000") ) );
        return;
    }
    *m_ptrMax_range = X;
    *m_ptrMax_angle = Y;


    QDialog::accept();

}
void sightdiagram_appearanceDlg::lstAngle_click(QModelIndex *item){
//     if(item == NULL)
//         return;
//     ui.txtAngle->setText(item->text() );


}
void sightdiagram_appearanceDlg::txtAngle_change(const QString &text)
{
    //ui.lstAngle->changeItem(text, ui.lstAngle->currentItem () );

}

