/***************************************************************************
 *   Copyright (C) 2009 by Herbert Roider   *
 *   herbert.roider@utanet.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *

 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef VISIER_DIAGRAM_H
#define VISIER_DIAGRAM_H

/**
 *@author Herbert Roider
 */

#include <QWidget>
#include <QPixmap>
#include <QPrinter>
#include <QMouseEvent>
#include <QPaintEvent>

#include "Armbrust.h"

#include <QLabel>


class QMenu;
class ArrowmatcherDoc;

/**
 */
class visier_diagram: public QWidget {
Q_OBJECT
public:
	/** Constructor for the main view */
	visier_diagram(QWidget *parent = 0);
	/** Destructor for the main view */
	~visier_diagram();

	ArrowmatcherDoc *getDocument() const;

	int get_impactparam(flight_snapshot & impactparam);
	/**  */
	ArrowmatcherDoc* m_doc;
	flightparam m_fp;
	/** buffer for the graphic output, for double buffering*/
	QPixmap *m_Pixmap;
	void recreate(ArrowmatcherDoc *doc);

private:

protected:
	void paintEvent(QPaintEvent *);
	double m_dFactor_x ;
	double m_dFactor_y ;
	double m_pan_y;
	/** No descriptions */
	void mousePressEvent(QMouseEvent *e);
	/** No descriptions */
	void mouseReleaseEvent(QMouseEvent *e);
	/** No descriptions */
	void mouseMoveEvent(QMouseEvent *e);
	virtual double y2diagram(double setting);
	virtual double y2diagram(utility::vector_3d setting);
	virtual double x2diagram(double range);
	virtual double y_setting(utility::vector_3d setting);

	QMenu *popup_options;

	void print_errormessage(QPainter &dc, QString & s);

	/** calculate the Interval for the scale */
	double calc_interval(double &dIntervall);


	int zeichnen(QPainter &dc, QRect &Rechteck);//Das Rechteck sollte ein Quadrat sein fr das Absehen.

	/** No descriptions */
	//void drawContents(QPainter* p, int cx, int cy, int cw, int ch);
	/** No descriptions */
	void drawDiagram(QPainter & dc);
	virtual int draw_sight_scale(QPainter &dc) = 0;
	//double m_dFactor_x;
	//double m_pan;//verschiebung des Bildausschnittes in der Vertikalen
	//double m_zoom;//Vergr�erungsfaktor fr das Bild (nur das Absehen!)
	int m_fontheight;

	/**  */
	QRect m_diagram_area;
	QRect m_window_area;

public slots:
	// Public slots
	/** No descriptions */
	void edit_options();

};

#endif
